//============================================================================
//	Apci8201w.pas
//
//	Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.
//
//	V1.00 Jun.1999
//
//============================================================================

unit Apci8201w;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs;

const
	//-------------------------------------
	// װ
	//-------------------------------------
	APCI8201_SUCCESS							=0;
	APCI8201_ERR_SYSTEM						=1;
  APCI8201_ERR_NO_DEVICE				=2;
  APCI8201_ERR_IN_USE						=3;
  APCI8201_ERR_INVALID_SOCKET		=4;
  APCI8201_ERR_RESOURCE					=5;
	APCI8201_ERR_INVALID_ARGUMENT	=6;
	APCI8201_ERR_NOTINIT					=7;
	APCI8201_ERR_MODE							=8;
	APCI8201_ERR_TIMEOUT					=9;
	APCI8201_ERR_NOLSN						=10;
	APCI8201_ERR_BUSY							=11;
	APCI8201_ERR_ETC							=12;
	APCI8201_ERR_WRAPDLL					=$ffff;	// ׯ߰֐װ
	//-------------------------------------
	// ײү(GPIB)w
	//-------------------------------------
	LA_0=$20;		// OLA
  TA_0=$40;		// OTA
	UNL	=$3f;		// UNListen
	UNT	=$5F;		// UNTalk
	GTL	=$01;		// Go To Local
	SDC	=$04;		// Select Device Clear
	GET	=$08;		// Group Execute Trigger
	LLO	=$11;		// Local Lock Out
	DCL	=$14;		// Device Clear
	SPE	=$18;		// Serial Poll Enable
	SPD	=$19;		// Serial Poll Disable
	PPC	=$05;		// Parallel Poll Config
	PPE	=$60;		// Parallel Poll Enable
	PPZ	=$70;		// Parallel Poll Disable
	PPU	=$15;		// Parallel Poll Unconfig
	TCT	=$09;		// Take Control (XXX)
	//-------------------------------------
	// GPIBð擾
	//-------------------------------------
	STS_IFC	=$01;		// IFC
	STS_DCAS=$02;		// DeviceClear
	STS_UNC	=$04;		// Ppoll,TCT etc
	STS_ERR	=$08;		// Error
	STS_GET	=$10;		// GET
	STS_SPAS=$20;		// Spoll
	STS_END	=$40;		// END
	STS_REM	=$00;		// Remote
	STS_LLO	=$00;		// LLO
	STS_TLK	=$00;		// Talker
	STS_LSN	=$00;		// Listener
	STS_ATN	=$00;		// ATN
	STS_SRQ	=$00;		// SRQ
	STS_REN	=$00;		// REN
	//-------------------------------------
	// GPIB֘AҰw͈
	//-------------------------------------
	ADDR_MIN				=0;				// ŏGPIBڽ
	ADDR_MAX				=30;			// ő    "
	TIMEOUT_DEFAULT	=2000;		// ѱ̫
	TIMEOUT_MAX			=60000;		// ѱčől
	//-------------------------------------
	// GPIBӰގw
	//-------------------------------------
	MODE_SYSCON			=1;				// Ѻ۰Ӱ
	MODE_TLKLSN			=0;				// İؽӰ
	//-------------------------------------
	// Ӱގw
	//-------------------------------------
	DELIM_CRLF			=1;				// CR + LF(̫)
	DELIM_CR				=2;				// CR
	DELIM_LF				=3;				// LF
	DELIM_NO				=0;				// NOTHING
	//-------------------------------------
	// EOIӰގw
	//-------------------------------------
	EOI_ON					=1;				// t(̫)
	EOI_OFF					=0;				// Ȃ
	//-------------------------------------
	// ̑萔
	//-------------------------------------
	APCI8201_DLL_NAME		= 'Apci8201.dll';	// DLĻٖ
	APCI8201_SLOT_AUTO=$FFFF;
	APCI8201_MAX_SLOTS=16;

	//-------------------------------------
	// ؿ\
	//-------------------------------------
	APCI8201_NMAX_MEM	=	9;
	APCI8201_NMAX_IO	= 20;
	APCI8201_NMAX_IRQ	=	7;
	APCI8201_NMAX_DMA	=	7;
type
	TAPCI8201RESOURCE = record
		dwNumMemWindows:																	DWORD;	// س޳(gp)
		dwMemBase:			array [1 .. APCI8201_NMAX_MEM] of	DWORD;	// س޳ްڽ(gp)
		dwMemLength:		array [1 .. APCI8201_NMAX_MEM] of	DWORD;	// س޳(gp)
		dwMemAttrib:		array [1 .. APCI8201_NMAX_MEM] of	DWORD;	// س޳(gp)
		dwNumIOPorts:																			DWORD;	// I/O߰Đ
		dwIOPortBase:		array [1 .. APCI8201_NMAX_IO]	 of	DWORD;	// I/O߰ްڽ
		dwIOPortLength: array [1 .. APCI8201_NMAX_IO]	 of	DWORD;	// I/O߰Ē
		dwNumIRQs:																				DWORD;	// IRQ(gp)
		dwIRQRegisters: array [1 .. APCI8201_NMAX_IRQ] of	DWORD;	// IRQؽ(gp)
		dwIRQAttrib:		array [1 .. APCI8201_NMAX_IRQ] of	DWORD;	// IRQؽ(gp)
		dwNumDMAs:																				DWORD;	// DMAِ(gp)
		dwDMALst:				array [1 .. APCI8201_NMAX_DMA] of	DWORD;	// DMAؽ(gp)
		dwDMAAttrib:		array [1 .. APCI8201_NMAX_DMA] of	DWORD;	// DMAّؽ(gp)
		dwReserved1:		array [1 .. 3] 						 		 of	DWORD;	// \(gp)
	end;
	PAPCI8201RESOURCE = ^TAPCI8201RESOURCE;

//-------------------------------------
// J֐
//-------------------------------------
// DLL ۰
function Apci8201wDllOpen: Boolean;
// DLL ۰
function Apci8201wDllClose: Boolean;
// װގ擾
function Apci8201wGetLastError(wLogSlot:WORD): DWORD;
// GPIBð̎擾
function Apci8201wGetStatus(wLogSlot:WORD): DWORD;
// DLL,޲ײްްޮݔԍ擾
function Apci8201wGetVersion(var pdwDllVersion:DWORD; var pdwDriverVersion:DWORD): Boolean;
// ޲̎gp錾
function Apci8201wCreate(var pwLogSlot:WORD): Boolean;
// ޲J
function Apci8201wClose(wLogSlot:WORD): Boolean;
// ؿ擾
function Apci8201wGetResource(wLogSlot:WORD; pResInfo:PAPCI8201RESOURCE): Boolean;
// GPIB
function Apci8201wInit(wLogSlot,wGpibAddr,wGpibMode:Word; dwFifoSize:DWord): Boolean;
// GPIBѱĐݒ
function Apci8201wSetTime(wLogSlot:Word; dwTimeoutCnt:DWord): Boolean;
// EOIݒ
function Apci8201wSetEos(wLogSlot,wDlmMode,wEoiMode:Word): Boolean;
// GPIBޑM(۰חp)
function Apci8201wSendCmd(wLogSlot:Word; var paSendBuf:array of Byte; dwSendBytes:DWord): Boolean;
// IFCM(۰חp)
function Apci8201wIfc(wLogSlot:Word): Boolean;
// RENײ݂̐ݒ(۰חp)
function Apci8201wRen(wLogSlot,wRenLine:Word): Boolean;
// DCLM(۰חp)
function Apci8201wDcl(wLogSlot:Word): Boolean;
// w@ւSDCM(۰חp)
function Apci8201wSdc(wLogSlot,wLsnAdrs:Word): Boolean;
// ̎w@ւްM(۰חp)
function Apci8201wSendDataCN(wLogSlot:Word; var pwLsnAdrsList:array of Word; wLsnAdrsCnt:Word; var pbSendBuff:array of Byte; dwDataCnt:DWord): Boolean;
// w@ւްM(۰חp)
function Apci8201wSendDataC(wLogSlot,wLsnAdrs:Word; var pbSendBuff:array of Byte; dwDataCnt:DWord): Boolean;
// ްM(ڰޗp)
function Apci8201wSendDataS(wLogSlot:Word; var pbSendBuff:array of Byte; dwDataCnt:DWord): Boolean;
// w@킩ްM(۰חp)
function Apci8201wRecvDataC(wLogSlot,wTlkAdrs:Word; var pbRecvBuff:array of Byte; var pdwDataCnt:DWord): Boolean;
// ްM(ڰޗp)
function Apci8201wRecvDataS(wLogSlot:Word; var pbRecvBuff:array of Byte; var pdwDataCnt:DWord): Boolean;
// @ް](۰חp)
function Apci8201wTransDataN(wLogSlot,wTlkAdrs:Word; var pwLsnAdrsList:array of Word; wLsnAdrsCnt:Word): Boolean;
// @ް](۰חp)
function Apci8201wTransData(wLogSlot,wTlkAdrs,wLsnAdrs:Word): Boolean;
// SRQײ݂ƽð޲Đݒ(ڰޗp)
function Apci8201wSetSrqLine(wLogSlot:Word; bStsByte:Byte): Boolean;
// SRQײ݂̏Ԕ(۰חp)
function Apci8201wGetSrqLine(wLogSlot:Word; var pwSrqLine:Word): Boolean;
// رَ߰s(۰חp)
function Apci8201wSpoll(wLogSlot,wPollAdrs:Word; var pbStsByte:Byte): Boolean;
// َ߰s(۰חp)
function Apci8201wPpoll(wLogSlot:Word; var pbDioLine:Byte): Boolean;
// ٍ߰\(۰חp)
function Apci8201wPpollConfig(wLogSlot,wLsnAdrs:Word; bDioLine:Byte; bSbit:Byte): Boolean;
// w@ٍ߰\(۰חp)
function Apci8201wPpollUnConfig(wLogSlot,wLsnAdrs:Word): Boolean;
// S@ٍ߰\(۰חp)
function Apci8201wPpollUnConfigAll(wLogSlot:Word): Boolean;
// ߰ىݒ(ڰޗp)
function Apci8201wPpollRespModeSet(wLogSlot,wPMode:Word): Boolean;
// BSN Switch ̒l擾
function Apci8201wGetSwitchValue(wLogSlot:Word;var pdwSwitchValue:DWord):Boolean;
// DIP-SW ̒l擾
function Apci8201wGetDipSwitch(wLogSlot:Word;var pbDipsw:Byte):Boolean;

//-------------------------------------
// (STATIC)ϐȂ
//-------------------------------------
implementation

{$J+}	// ^t萔̕ύX\߲׎w
const
	hDLL: THandle = 0;

type
	TApci8201GetLastError = function(wLogSlot:WORD): DWORD; stdcall;
	TApci8201GetStatus = function(wLogSlot:WORD): DWORD; stdcall;
	TApci8201GetVersion = function(var pdwDllVersion:DWORD; var pdwDriverVersion:DWORD): Boolean; stdcall;
	TApci8201Create = function(var pwLogSlot): Boolean; stdcall;
	TApci8201Close = function(wLogSlot:WORD): Boolean; stdcall;
	TApci8201GetResource = function(wLogSlot:WORD; pResInfo:PAPCI8201RESOURCE): Boolean; stdcall;
	TApci8201Init = function(wLogSlot,wGpibAddr,wGpibMode:Word; dwFifoSize:DWord): Boolean; stdcall;
	TApci8201SetTime = function(wLogSlot:Word; dwTimeoutCnt:DWord): Boolean; stdcall;
	TApci8201SetEos = function(wLogSlot,wDlmMode,wEoiMode:Word): Boolean; stdcall;
	TApci8201SendCmd = function(wLogSlot:Word; paSendBuf:PChar; dwSendBytes:DWord): Boolean; stdcall;
	TApci8201Ifc = function(wLogSlot:Word): Boolean; stdcall;
	TApci8201Ren = function(wLogSlot,wRenLine:Word): Boolean; stdcall;
	TApci8201Dcl = function(wLogSlot:Word): Boolean; stdcall;
	TApci8201Sdc = function(wLogSlot,wLsnAdrs:Word): Boolean; stdcall;
	TApci8201SendDataCN = function(wLogSlot:Word; pwLsnAdrsList:PWordArray; wLsnAdrsCnt:Word; pbSendBuff:PChar; dwDataCnt:DWord): Boolean; stdcall;
	TApci8201SendDataC = function(wLogSlot,wLsnAdrs:Word; pbSendBuff:PChar; dwDataCnt:DWord): Boolean; stdcall;
	TApci8201SendDataS = function(wLogSlot:Word; pbSendBuff:PChar; dwDataCnt:DWord): Boolean; stdcall;
	TApci8201RecvDataC = function(wLogSlot,wTlkAdrs:Word; pbRecvBuff:PChar; var pdwDataCnt:DWord): Boolean; stdcall;
	TApci8201RecvDataS = function(wLogSlot:Word; pbRecvBuff:PChar; var pdwDataCnt:DWord): Boolean; stdcall;
	TApci8201TransDataN = function(wLogSlot,wTlkAdrs:Word; pwLsnAdrsList:PWordArray; wLsnAdrsCnt:Word): Boolean; stdcall;
	TApci8201TransData = function(wLogSlot,wTlkAdrs,wLsnAdrs:Word): Boolean; stdcall;
	TApci8201SetSrqLine = function(wLogSlot:Word; bStsByte:Byte): Boolean; stdcall;
	TApci8201GetSrqLine = function(wLogSlot:Word; var pwSrqLine:Word): Boolean; stdcall;
	TApci8201Spoll = function(wLogSlot,wPollAdrs:Word; var pbStsByte:Byte): Boolean; stdcall;
	TApci8201Ppoll = function(wLogSlot:Word; var pbDioLine:Byte): Boolean; stdcall;
	TApci8201PpollConfig = function(wLogSlot,wLsnAdrs:Word; bDioLine:Byte; bSbit:Byte): Boolean; stdcall;
	TApci8201PpollUnConfig = function(wLogSlot,wLsnAdrs:Word): Boolean; stdcall;
	TApci8201PpollUnConfigAll = function(wLogSlot:Word): Boolean; stdcall;
	TApci8201PpollRespModeSet = function(wLogSlot,wPMode:Word): Boolean; stdcall;
	TApci8201GetSwitchValue	= function(wLogSlot:Word;var pdwSwitchValue:DWord):Boolean;stdcall;
	TApci8201GetDipSwitch = function(wLogSlot:Word;var pbDipsw:Byte):Boolean;stdcall;

// DLL ߰Ċ֐ڽ̊i[ϐ
var
	pApci8201GetLastError:			TApci8201GetLastError;
	pApci8201GetStatus:					TApci8201GetStatus;
	pApci8201GetVersion: 				TApci8201GetVersion;
	pApci8201Create: 						TApci8201Create;
	pApci8201Close: 						TApci8201Close;
	pApci8201GetResource: 			TApci8201GetResource;
	pApci8201Init:							TApci8201Init;
	pApci8201SetTime:						TApci8201SetTime;
	pApci8201SetEos:						TApci8201SetEos;
	pApci8201SendCmd:						TApci8201SendCmd;
	pApci8201Ifc:								TApci8201Ifc;
	pApci8201Ren:								TApci8201Ren;
	pApci8201Dcl:								TApci8201Dcl;
	pApci8201Sdc:								TApci8201Sdc;
	pApci8201SendDataCN:				TApci8201SendDataCN;
	pApci8201SendDataC:					TApci8201SendDataC;
	pApci8201SendDataS:					TApci8201SendDataS;
	pApci8201RecvDataC:					TApci8201RecvDataC;
	pApci8201RecvDataS:					TApci8201RecvDataS;
	pApci8201TransDataN:				TApci8201TransDataN;
	pApci8201TransData:					TApci8201TransData;
	pApci8201SetSrqLine:				TApci8201SetSrqLine;
	pApci8201GetSrqLine:				TApci8201GetSrqLine;
	pApci8201Spoll:							TApci8201Spoll;
	pApci8201Ppoll:							TApci8201Ppoll;
	pApci8201PpollConfig:				TApci8201PpollConfig;
	pApci8201PpollUnConfig:			TApci8201PpollUnConfig;
	pApci8201PpollUnConfigAll:	TApci8201PpollUnConfigAll;
	pApci8201PpollRespModeSet:	TApci8201PpollRespModeSet;
	pApci8201GetSwitchValue:		TApci8201GetSwitchValue;
	pApci8201GetDipSwitch:			TApci8201GetDipSwitch;

  function _Apci8201wGetDllExportFunc: Boolean; forward;

{$J-}

//============================================================================
// 		DLL۰(۰ގʹװƂ)
// 		
// ߂l  True
//				s False
//============================================================================
function Apci8201wDllOpen: Boolean;
begin
	Result:=False;
	if hDLL=0 then begin
		hDLL:=LoadLibrary(APCI8201_DLL_NAME);
		if hDLL<>0 then begin
			if _Apci8201wGetDllExportFunc=True then begin
      	Result:=True
			end else Apci8201wDllClose;	// DLL֐擾ɎŝDLLN[Y
		end;
	end;
end;
//============================================================================
// 		DLL۰(۰ގʹװƂ)
// 		
// ߂l  True
//				s False
//============================================================================
function Apci8201wDllClose: Boolean;
begin
	Result:=False;
	if hDLL<>0 then begin
		if True=FreeLibrary(hDLL) then begin
			hDLL:=0;
			Result:=True;
		end;
	end;
end;
//============================================================================
// 		װނ̎擾
// 		wLogSlot	޲̘_Ĕԍ
// ߂l װ
//============================================================================
function Apci8201wGetLastError(wLogSlot:WORD): DWORD;
begin
	if hDLL=0 then Result:=APCI8201_ERR_WRAPDLL
	else Result:=pApci8201GetLastError(wLogSlot)
end;
//============================================================================
// 		GPIBð̎擾
// 		wLogSlot	޲̘_Ĕԍ
// ߂l  True
//				s False
//============================================================================
function Apci8201wGetStatus(wLogSlot:WORD): DWORD;
begin
	Result := 0;
	if hDLL = 0 then Exit;
	Result:=pApci8201GetStatus(wLogSlot);
end;
//============================================================================
// 		DLL,޲ײްްޮݔԍ擾
// 		pdwDllVersion			DLLްޮݔԍi[̈ւ߲
//				pdwDriverVersion	޲ײްްޮݔԍi[̈ւ߲
// ߂l  True
//				s False
//============================================================================
function Apci8201wGetVersion(var pdwDllVersion:DWORD; var pdwDriverVersion:DWORD): Boolean;
begin
	Result := False;
	if hDLL = 0 then Exit;
	Result:=pApci8201GetVersion(pdwDllVersion, pdwDriverVersion);
end;
//============================================================================
// 		޲̎gp錾
// 		pwLogSlot	 	gp޲̘_Ĕԍi[߲
// ߂l  True
//				s False
//============================================================================
function Apci8201wCreate(var pwLogSlot:WORD): Boolean;
begin
	Result := False;
	if hDLL = 0 then Exit;
	Result:=pApci8201Create(pwLogSlot);
end;
//============================================================================
// 		޲J
// 		wLogSlot ޲̘_Ĕԍ
// ߂l  True
//				s False
//============================================================================
function Apci8201wClose(wLogSlot:WORD): Boolean;
begin
	Result := False;
	if hDLL = 0 then Exit;
	Result:=pApci8201Close(wLogSlot)
end;
//============================================================================
// 		w޲ؿ擾
// 		wLogSlot	޲̘_Ĕԍ
//				pResInfo		ؿi[\߲̂
// ߂l  True
//				s False
//============================================================================
function Apci8201wGetResource(wLogSlot:WORD; pResInfo:PAPCI8201RESOURCE): Boolean;
begin
	Result := False;
	if hDLL = 0 then Exit;
	Result:=pApci8201GetResource(wLogSlot, pResInfo)
end;
//============================================================================
// 		
// 		wLogSlot	޲̘_Ĕԍ
//				wGpibAddr   g GP-IB AhX
//				wGpibMode		g GP-IB 샂[h
//				dwFifoSize	Mobt@̑傫
// ߂l  True
//				s False
//============================================================================
function Apci8201wInit(wLogSlot,wGpibAddr,wGpibMode:Word; dwFifoSize:DWord): Boolean;
begin
	Result := False;
	if hDLL = 0 then Exit;
	Result:=pApci8201Init(wLogSlot,wGpibAddr,wGpibMode,dwFifoSize);
end;
//============================================================================
// 		GPIBѱĐݒ
// 		wLogSlot		޲̘_Ĕԍ
//				dwTimeoutCnt  ^CAEglBPʂ̓~b0`60000܂ŁB
// ߂l  True
//				s False
//============================================================================
function Apci8201wSetTime(wLogSlot:Word; dwTimeoutCnt:DWord): Boolean;
begin
	Result := False;
	if hDLL = 0 then Exit;
	Result:=pApci8201SetTime(wLogSlot,dwTimeoutCnt);
end;
//============================================================================
// 		EOIݒ
// 		wLogSlot	޲̘_Ĕԍ
//				wDlmMode    f~^w
//				wEoiMode    dnh̎gp܂͕sgpw
// ߂l  True
//				s False
//============================================================================
function Apci8201wSetEos(wLogSlot,wDlmMode,wEoiMode:Word): Boolean;
begin
	Result := False;
	if hDLL = 0 then Exit;
	Result:=pApci8201SetEos(wLogSlot,wDlmMode,wEoiMode);
end;
//============================================================================
// 		GPIBޑM(۰חp)
// 		wLogSlot	޲̘_Ĕԍ
//				paSendBuf   MR}hobt@̃AhX
//				dwSendBytes	MׂR}h̃oCg
// ߂l  True
//				s False
//============================================================================
function Apci8201wSendCmd(wLogSlot:Word; var paSendBuf:array of Byte; dwSendBytes:DWord): Boolean;
begin
	Result := False;
	if hDLL = 0 then Exit;
	Result:=pApci8201SendCmd(wLogSlot,PChar(@paSendBuf),dwSendBytes);
end;
//============================================================================
// 		IFCM(۰חp)
// 		wLogSlot	޲̘_Ĕԍ
// ߂l  True
//				s False
//============================================================================
function Apci8201wIfc(wLogSlot:Word): Boolean;
begin
	Result := False;
	if hDLL = 0 then Exit;
	Result:=pApci8201Ifc(wLogSlot);
end;
//============================================================================
// 		RENײ݂̐ݒ(۰חp)
// 		wLogSlot	޲̘_Ĕԍ
//				wRenLine		1(^)/0(U)
// ߂l  True
//				s False
//============================================================================
function Apci8201wRen(wLogSlot,wRenLine:Word): Boolean;
begin
	Result := False;
	if hDLL = 0 then Exit;
	Result:=pApci8201Ren(wLogSlot,wRenLine);
end;
//============================================================================
// 		DCLM(۰חp)
// 		wLogSlot	޲̘_Ĕԍ
// ߂l  True
//				s False
//============================================================================
function Apci8201wDcl(wLogSlot:Word): Boolean;
begin
	Result := False;
	if hDLL = 0 then Exit;
	Result:=pApci8201Dcl(wLogSlot);
end;
//============================================================================
// 		w@ւSDCM(۰חp)
// 		wLogSlot	޲̘_Ĕԍ
//				wLsnAdrs		XiAhX
// ߂l  True
//				s False
//============================================================================
function Apci8201wSdc(wLogSlot,wLsnAdrs:Word): Boolean;
begin
	Result := False;
	if hDLL = 0 then Exit;
	Result:=pApci8201Sdc(wLogSlot,wLsnAdrs);
end;
//============================================================================
// 		̎w@ւްM(۰חp)
// 		wLogSlot		޲̘_Ĕԍ
//				pwLsnAdrsList XiAhXXg̃AhX
//				wLsnAdrsCnt		XiAhX̐
//				pbSendBuff		Mf[^obt@̃AhX
//				dwDataCnt			Mf[^
// ߂l  True
//				s False
//============================================================================
function Apci8201wSendDataCN(wLogSlot:Word; var pwLsnAdrsList:array of Word; wLsnAdrsCnt:Word; var pbSendBuff:array of Byte; dwDataCnt:DWord): Boolean;
begin
	Result := False;
	if hDLL = 0 then Exit;
	Result:=pApci8201SendDataCN(wLogSlot,PWordArray(@pwLsnAdrsList),wLsnAdrsCnt,PChar(@pbSendBuff),dwDataCnt);
end;
//============================================================================
// 		w@ւްM(۰חp)
// 		wLogSlot	޲̘_Ĕԍ
//				wLsnAdrs		XiAhX
//				pbSendBuff	Mf[^obt@̃AhX
//				dwDataCnt   Mf[^
// ߂l  True
//				s False
//============================================================================
function Apci8201wSendDataC(wLogSlot,wLsnAdrs:Word; var pbSendBuff:array of Byte; dwDataCnt:DWord): Boolean;
begin
	Result := False;
	if hDLL = 0 then Exit;
	Result:=pApci8201SendDataC(wLogSlot,wLsnAdrs,PChar(@pbSendBuff),dwDataCnt);
end;
//============================================================================
// 		ްM(ڰޗp)
// 		wLogSlot	޲̘_Ĕԍ
//				pbSendBuff	Mf[^obt@̃AhX
//				dwDataCnt		Mf[^
// ߂l  True
//				s False
//============================================================================
function Apci8201wSendDataS(wLogSlot:Word; var pbSendBuff:array of Byte; dwDataCnt:DWord): Boolean;
begin
	Result := False;
	if hDLL = 0 then Exit;
	Result:=pApci8201SendDataS(wLogSlot,PChar(@pbSendBuff),dwDataCnt);
end;
//============================================================================
// 		w@킩ްM(۰חp)
// 		wLogSlot	޲̘_Ĕԍ
//				wTlkAdrs		g[JAhX
//				pbRecvBuff	Mf[^obt@̃AhX
//				pdwDataCnt	Mf[^w肷ϐ̃AhX
// ߂l  True
//				s False
//============================================================================
function Apci8201wRecvDataC(wLogSlot,wTlkAdrs:Word; var pbRecvBuff:array of Byte; var pdwDataCnt:DWord): Boolean;
begin
	Result := False;
	if hDLL = 0 then Exit;
	Result:=pApci8201RecvDataC(wLogSlot,wTlkAdrs,PChar(@pbRecvBuff),pdwDataCnt);
end;
//============================================================================
// 		ްM(ڰޗp)
// 		wLogSlot	޲̘_Ĕԍ
//				pbRecvBuff  Mf[^obt@̃AhX
//				pdwDataCnt  Mf[^w肷ϐ̃AhX
// ߂l  True
//				s False
//============================================================================
function Apci8201wRecvDataS(wLogSlot:Word; var pbRecvBuff:array of Byte; var pdwDataCnt:DWord): Boolean;
begin
	Result := False;
	if hDLL = 0 then Exit;
	Result:=pApci8201RecvDataS(wLogSlot,PChar(@pbRecvBuff),pdwDataCnt);
end;
//============================================================================
// 		@ް](۰חp)
// 		wLogSlot		޲̘_Ĕԍ
//				wTlkAdrs      g[JAhX
//				pwLsnAdrsList	XiAhXXg̃AhX
//				wLsnAdrsCnt		XiAhX̐
// ߂l  True
//				s False
//============================================================================
function Apci8201wTransDataN(wLogSlot,wTlkAdrs:Word; var pwLsnAdrsList:array of Word; wLsnAdrsCnt:Word): Boolean;
begin
	Result := False;
	if hDLL = 0 then Exit;
	Result:=pApci8201TransDataN(wLogSlot,wTlkAdrs,PWordArray(@pwLsnAdrsList),wLsnAdrsCnt);
end;
//============================================================================
// 		@ް](۰חp)
// 		wLogSlot	޲̘_Ĕԍ
//				wTlkAdrs		g[JAhX
//				wLsnAdrs		XiAhX
// ߂l  True
//				s False
//============================================================================
function Apci8201wTransData(wLogSlot,wTlkAdrs,wLsnAdrs:Word): Boolean;
begin
	Result := False;
	if hDLL = 0 then Exit;
	Result:=pApci8201TransData(wLogSlot,wTlkAdrs,wLsnAdrs);
end;
//============================================================================
// 		SRQײ݂ƽð޲Đݒ(ڰޗp)
// 		wLogSlot	޲̘_Ĕԍ
//				bStsByte		Xe[^XoCgl
// ߂l  True
//				s False
//============================================================================
function Apci8201wSetSrqLine(wLogSlot:Word; bStsByte:Byte): Boolean;
begin
	Result := False;
	if hDLL = 0 then Exit;
	Result:=pApci8201SetSrqLine(wLogSlot,bStsByte);
end;
//============================================================================
// 		SRQײ݂̏Ԕ(۰חp)
// 		wLogSlot	޲̘_Ĕԍ
//				pwSrqLine		rqpCԂi[ϐ̃AhX
// ߂l  True
//				s False
//============================================================================
function Apci8201wGetSrqLine(wLogSlot:Word; var pwSrqLine:Word): Boolean;
begin
	Result := False;
	if hDLL = 0 then Exit;
	Result:=pApci8201GetSrqLine(wLogSlot,pwSrqLine);
end;
//============================================================================
// 		رَ߰s(۰חp)
// 		wLogSlot	޲̘_Ĕԍ
//				wPollAdrs		|[ÕAhX
//				pbStsByte		Xe[^XoCgi[ϐ̃AhX
// ߂l  True
//				s False
//============================================================================
function Apci8201wSpoll(wLogSlot,wPollAdrs:Word; var pbStsByte:Byte): Boolean;
begin
	Result := False;
	if hDLL = 0 then Exit;
	Result:=pApci8201Spoll(wLogSlot,wPollAdrs,pbStsByte);
end;
//============================================================================
// 		َ߰s(۰חp)
// 		wLogSlot	޲̘_Ĕԍ
//				pbDioLine   chnCi[ϐ̃AhX
// ߂l  True
//				s False
//============================================================================
function Apci8201wPpoll(wLogSlot:Word; var pbDioLine:Byte): Boolean;
begin
	Result := False;
	if hDLL = 0 then Exit;
	Result:=pApci8201Ppoll(wLogSlot,pbDioLine);
end;
//============================================================================
// 		ٍ߰\(۰חp)
// 		wLogSlot	޲̘_Ĕԍ
//				wLsnAdrs		\@AhX
//				bDioLine    @tDIOCԍiO`ṼrbgԍŎwj
//				bSbit				ZXrbg̎wiO܂͂Pj
// ߂l  True
//				s False
//============================================================================
function Apci8201wPpollConfig(wLogSlot,wLsnAdrs:Word; bDioLine:Byte; bSbit:Byte): Boolean;
begin
	Result := False;
	if hDLL = 0 then Exit;
	Result:=pApci8201PpollConfig(wLogSlot,wLsnAdrs,bDioLine,bSbit);
end;
//============================================================================
// 		w@ٍ߰\(۰חp)
// 		wLogSlot	޲̘_Ĕԍ
//				wLsnAdrs		\@AhX
// ߂l  True
//				s False
//============================================================================
function Apci8201wPpollUnConfig(wLogSlot,wLsnAdrs:Word): Boolean;
begin
	Result := False;
	if hDLL = 0 then Exit;
	Result:=pApci8201PpollUnConfig(wLogSlot,wLsnAdrs);
end;
//============================================================================
// 		S@ٍ߰\(۰חp)
// 		wLogSlot	޲̘_Ĕԍ
// ߂l  True
//				s False
//============================================================================
function Apci8201wPpollUnConfigAll(wLogSlot:Word): Boolean;
begin
	Result := False;
	if hDLL = 0 then Exit;
	Result:=pApci8201PpollUnConfigAll(wLogSlot);
end;
//============================================================================
// 		߰ىݒ(ڰޗp)
// 		wLogSlot	޲̘_Ĕԍ
//				wPMode			p|[ւ̉@
// ߂l  True
//				s False
//============================================================================
function Apci8201wPpollRespModeSet(wLogSlot,wPMode:Word): Boolean;
begin
	Result := False;
	if hDLL = 0 then Exit;
	Result:=pApci8201PpollRespModeSet(wLogSlot,wPMode);
end;
//============================================================================
// 		arm̒l擾
// 		wLogSlot				޲̘_Ĕԍ
//				pdwSwitchValue  arm̒li[̈
// ߂l  True
//				s False
//============================================================================
function Apci8201wGetSwitchValue(wLogSlot: WORD; var pdwSwitchValue: DWORD ): Boolean;
begin
	Result := False;
	if hDLL = 0 then Exit;
	Result:=pApci8201GetSwitchValue(wLogSlot,pdwSwitchValue);
end;
//============================================================================
// 		DIP-SW ̒l擾܂
// 		wLogSlot				޲̘_Ĕԍ
//				pbDipsw         DIP-SW̒li[̈
// ߂l  True
//				s False
//============================================================================
function Apci8201wGetDipSwitch(wLogSlot: WORD; var pbDipsw: BYTE ): Boolean;
begin
	Result := False;
	if hDLL = 0 then Exit;
	Result:=pApci8201GetDipSwitch(wLogSlot,pbDipsw);
end;
//----------------------------------------------------------------------------
// 	  DLL߰Ċ֐ڽ̎擾
// 	  
// ߂l  True
//		  	s False
//----------------------------------------------------------------------------
function _Apci8201wGetDllExportFunc: Boolean;
begin
	Result:=False;
	pApci8201GetLastError:=GetProcAddress(hDLL, 'Apci8201GetLastError');
	if @pApci8201GetLastError=nil then Exit;
	pApci8201GetStatus:=GetProcAddress(hDLL, 'Apci8201GetStatus');
	if @pApci8201GetStatus=nil then Exit;
	pApci8201GetVersion:=GetProcAddress(hDLL, 'Apci8201GetVersion');
	if @pApci8201GetVersion=nil then Exit;
	pApci8201Create:=GetProcAddress(hDLL, 'Apci8201Create');
	if @pApci8201Create=nil then Exit;
	pApci8201Close:=GetProcAddress(hDLL, 'Apci8201Close');
	if @pApci8201Close=nil then Exit;
	pApci8201GetResource:=GetProcAddress(hDLL, 'Apci8201GetResource');
	if @pApci8201GetResource=nil then Exit;
	pApci8201Init:=GetProcAddress(hDLL, 'Apci8201Init');
	if @pApci8201Init=nil then Exit;
	pApci8201SetTime:=GetProcAddress(hDLL, 'Apci8201SetTime');
	if @pApci8201SetTime=nil then Exit;
	pApci8201SetEos:=GetProcAddress(hDLL, 'Apci8201SetEos');
	if @pApci8201SetEos=nil then Exit;
	pApci8201SendCmd:=GetProcAddress(hDLL, 'Apci8201SendCmd');
	if @pApci8201SendCmd=nil then Exit;
	pApci8201Ifc:=GetProcAddress(hDLL, 'Apci8201Ifc');
	if @pApci8201Ifc=nil then Exit;
	pApci8201Ren:=GetProcAddress(hDLL, 'Apci8201Ren');
	if @pApci8201Ren=nil then Exit;
	pApci8201Dcl:=GetProcAddress(hDLL, 'Apci8201Dcl');
	if @pApci8201Dcl=nil then Exit;
	pApci8201Sdc:=GetProcAddress(hDLL, 'Apci8201Sdc');
	if @pApci8201Sdc=nil then Exit;
	pApci8201SendDataCN:=GetProcAddress(hDLL, 'Apci8201SendDataCN');
	if @pApci8201SendDataCN=nil then Exit;
	pApci8201SendDataC:=GetProcAddress(hDLL, 'Apci8201SendDataC');
	if @pApci8201SendDataC=nil then Exit;
	pApci8201SendDataS:=GetProcAddress(hDLL, 'Apci8201SendDataS');
	if @pApci8201SendDataS=nil then Exit;
	pApci8201RecvDataC:=GetProcAddress(hDLL, 'Apci8201RecvDataC');
	if @pApci8201RecvDataC=nil then Exit;
	pApci8201RecvDataS:=GetProcAddress(hDLL, 'Apci8201RecvDataS');
	if @pApci8201RecvDataS=nil then Exit;
	pApci8201TransDataN:=GetProcAddress(hDLL, 'Apci8201TransDataN');
	if @pApci8201TransDataN=nil then Exit;
	pApci8201TransData:=GetProcAddress(hDLL, 'Apci8201TransData');
	if @pApci8201TransData=nil then Exit;
	pApci8201SetSrqLine:=GetProcAddress(hDLL, 'Apci8201SetSrqLine');
	if @pApci8201SetSrqLine=nil then Exit;
	pApci8201GetSrqLine:=GetProcAddress(hDLL, 'Apci8201GetSrqLine');
	if @pApci8201GetSrqLine=nil then Exit;
	pApci8201Spoll:=GetProcAddress(hDLL, 'Apci8201Spoll');
	if @pApci8201Spoll=nil then Exit;
	pApci8201Ppoll:=GetProcAddress(hDLL, 'Apci8201Ppoll');
	if @pApci8201Ppoll=nil then Exit;
	pApci8201PpollConfig:=GetProcAddress(hDLL, 'Apci8201PpollConfig');
	if @pApci8201PpollConfig=nil then Exit;
	pApci8201PpollUnConfig:=GetProcAddress(hDLL, 'Apci8201PpollUnConfig');
	if @pApci8201PpollUnConfig=nil then Exit;
	pApci8201PpollUnConfigAll:=GetProcAddress(hDLL, 'Apci8201PpollUnConfigAll');
	if @pApci8201PpollUnConfigAll=nil then Exit;
	pApci8201PpollRespModeSet:=GetProcAddress(hDLL, 'Apci8201PpollRespModeSet');
	if @pApci8201PpollRespModeSet=nil then Exit;
	pApci8201GetSwitchValue:=GetProcAddress(hDLL, 'Apci8201GetSwitchValue');
	if @pApci8201GetSwitchValue=nil then Exit;
	pApci8201GetDipSwitch:=GetProcAddress(hDLL, 'Apci8201GetDipSwitch');
	if @pApci8201GetDipSwitch=nil then Exit;

	// SĂ DLL ߰Ċ֐ڽ擾nj
	Result:=True;
end;

end.

